﻿Imports System.IO
Imports System.Console
Imports System.Xml

REM This program is NOT Free Software.
REM Copyright (C) 2011 Toufukun, all right reserved

Module main
    Public ofs As StreamWriter
    Sub WriteNote(ByRef Num As Integer, ByVal Dur As Integer, ByVal NoteNum As Integer, ByVal Lyric As String, ByVal Velo As Integer)
        ofs.WriteLine("[#" & Format(Num, "0000") & "]")
        ofs.WriteLine("Length=" & Dur)
        ofs.WriteLine("Lyric=" & Lyric)
        ofs.WriteLine("NoteNum=" & NoteNum)
        ofs.WriteLine("Intensity=" & Velo)
        ofs.WriteLine("Moduration=0")
        Num += 1
    End Sub
    Sub Main()
        Dim cmdpar() As String = System.Environment.GetCommandLineArgs
        Dim vsqxdir As String
            Dim vsqxdoc As New XmlDocument()
            Dim ofilename As String
        WriteLine("VSQx to UST Converter 0.1.2 beta by Toufukun")
        WriteLine()
        If cmdpar.Length = 1 Then
            WriteLine("You can also drag the VSQx file to the program's icon.")
            Write("VSQx file input: ")
            vsqxdir = ReadLine()
        Else
            vsqxdir = cmdpar(1)
        End If
        vsqxdoc.Load(vsqxdir)
        Dim nsman As XmlNamespaceManager = New XmlNamespaceManager(vsqxdoc.NameTable)
        nsman.AddNamespace("v3", "http://www.yamaha.co.jp/vocaloid/schema/vsq3/")
        Dim vsqx As XmlNode = vsqxdoc.SelectSingleNode("v3:vsq3", nsman)
        Dim temponode = vsqx.SelectSingleNode("v3:masterTrack/v3:tempo/v3:bpm", nsman)
        Dim tempo As Double = Val(temponode.InnerText) / 100
        Dim vstracklist As XmlNodeList = vsqx.SelectNodes("v3:vsTrack", nsman)
        Dim vstrack As XmlNode
        For Each vstrack In vstracklist
            Dim trackno As XmlNode = vstrack.SelectSingleNode("v3:vsTrackNo", nsman)
            Dim tracknonum As Integer = Val(trackno.InnerText)
            Dim musicalpartlist As XmlNodeList = vstrack.SelectNodes("v3:musicalPart", nsman)
            Dim musicalpart As XmlNode
            Dim trackname As String = vstrack.SelectSingleNode("v3:trackName", nsman).InnerText
            Dim partno As Integer = 0
            For Each musicalpart In musicalpartlist
                partno += 1
                ofilename = Left(vsqxdir, Len(vsqxdir) - 5) & "_t" & tracknonum & _
                    "_p" & partno & ".ust"
                WriteLine("Track No." & tracknonum & ", Part No." & _
                          partno & " will be converted into " & ofilename)
                Dim partname As String = musicalpart.SelectSingleNode("v3:partName", nsman).InnerText
                WriteLine("Track Name is " & trackname & ", Part Name is " & partname)
                ofs = New StreamWriter(ofilename, False, System.Text.Encoding.GetEncoding(932))
                ofs.WriteLine("[#SETTING]")
                ofs.WriteLine("Tempo=" & Format(tempo, "0.00"))
                ofs.WriteLine("Tracks=1")
                ofs.WriteLine("ProjectName=VSQx2UST Converted Sequence")
                Dim notelist As XmlNodeList = musicalpart.SelectNodes("v3:note", nsman)
                Dim nonote As Integer = 0
                Dim note As XmlNode
                Dim LastNoteEnd As Integer = 0
                Dim NoteDur, NotePos, NoteVel, NoteNum As Integer
                Dim NoteLrc As String
                For Each note In notelist
                    NotePos = Val(note.SelectSingleNode("v3:posTick", nsman).InnerText)
                    If LastNoteEnd <> NotePos Then
                        WriteNote(nonote, NotePos - LastNoteEnd, 60, "R", 100)
                    End If
                    NoteDur = Val(note.SelectSingleNode("v3:durTick", nsman).InnerText)
                    NoteVel = Val(note.SelectSingleNode("v3:velocity", nsman).InnerText) / 64 * 100
                    NoteLrc = note.SelectSingleNode("v3:lyric", nsman).InnerText
                    NoteNum = Val(note.SelectSingleNode("v3:noteNum", nsman).InnerText)
                    WriteNote(nonote, NoteDur, NoteNum, NoteLrc, NoteVel)
                    LastNoteEnd = NotePos + NoteDur
                Next
                ofs.WriteLine("[#TRACKEND]")
                ofs.Close()
                WriteLine("This Part is successfully converted. It has " & nonote & " notes.")
            Next
        Next
        WriteLine("All Tracks and Parts' process done. Please press enter to exit.")
        ReadLine()
    End Sub

End Module
